////

FUNCTION OpenEH(cOne,cTwo,cThree,cFour,cFive,cSix,cSeven)

////
   EXPERTBEGIN
   !short: OpenEH() Opening Function, EHmaker.PRG, sets path, statics, etc.

   syntax..............: OpenEH([<list of params>])
   parameters passed...: list of params: 7 to date.
   return value........: nil.
   action..............: check to see if template file is available using
                         parameter and defaults, return if it cannot find
                         template.  checks save path if not found prompts
                         before writing on path/filename.
   notes...............: stores defaults to an array and checks disk for
                         for template.eh and ehmaker.cfg.

                         note:
                         if a name is passed as the third parameter,
                         builds an array file names is processed.
   called function(s)..: ArrayRead()     = read in two dimensional array
                                           of file names.
                         BatchEH()       = the top most eh file dos
                                           function.
                         DOSparams()     = test for parameters passed
                                           from dos.
                         EHmaker()       = the top most eh file menu
                                           function.
                         CamelotLOGO()   = scroll company logo.
                         TemplateEH()    = build template, config arrays.
   calling function(s).: none. (dos).
   related functions(s): none.
   all function(s).....: ArrayRead()    // process 2 dimensional filename
                                           array.
                         BatchEH()      // process file of dosfile names.
                         BlockEH()      // building block/parsing function.
                         CamelotLOGO()  // display firm name.
                         ConvertToEH()  // converts single lines to expert
                                           help format.
                         DOSparams()    // evaluate dos parameters.
                         Elevator()     // elevator bar for achoice()
                         ElevatorUDF()  // achoice() udf to call Elevator()
                         MenuEH()       // building block/parsing function.
                         PATHfiles()   // check path syntax.
                         QuitEH()       // quit EHmaker.
                         ScrollHits()   // display selected file names.
                         TemplateEH()   // array gathering function.
                         WriteEH()      // write file function.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: ArrayRead() BatchEH() DOSparams() EHmaker() TemplateEH() QuitEH()       
   EXPERTEND

////

FUNCTION ArrayRead(cFile)

////
   EXPERTBEGIN
   !short: ArrayRead()   Read a file into a two dimensional array.

   syntax..............: ArrayRead(<file name>)
   parameters passed...: cFile   = file name.
   return value........: filled array.
   action..............: build and array from a text file
   notes...............: use low level functions to read a text file
                         into a two dimensional array.
   called function(s)..: none.
   calling function(s).: OpenEH().
   related functions(s): ArrayWrite().
   revision history....: written in 1987, revised in 1992.
   credits.............: none.
   copyright notice....: copyright (c),1987, 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: OpenEH()
   EXPERTEND

////

FUNCTION BatchEH(aBatchIT)

////
   EXPERTBEGIN
   !short: BatchEH()    Process an array of files passed from DOS.

   syntax..............: BatchEH(<array>)
   parameters passed...: aBatchIT  = array of files passed from dos.
   return value........: nil.
   action..............: passes an array element (file name) to BlockEH()
                         for processing.
   notes...............: topmost dos driven controlling function.  displays
                         screen, tests for valid file name, passes file
                         name to BlockEH() for processing and WriteEH()
                         for printing.  counterpart for menu driven use is
                         Ehmaker().  Converts text file headers into files
                         compatible with the Expert Help compiler.  uses a
                         "template.eh", and "ehmaker.cfg" text file located
                         in the clipper \include subdirectory.
   called function(s)..: BlockEH()
   calling function(s).: OpenEH()
                         WriteEH()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: BlockEH() OpenEH() WriteEH()
   EXPERTEND
////

FUNCTION BlockEH(cFile)

////
   EXPERTBEGIN
   !short: BlockEH()     Block out lines of text from a text file.

   syntax..............: BlockEH(<.prg>)
   parameters passed...: cFile  = .prg to process.
   return value........: aBlockIT, modified array of values.
   action..............: access the text files on disk and build an array.
   notes...............: builds an array of text files where each element
                         is a single line of the function header.  then
                         passes the single element as a string to the
                         function ConvertToEH() which process each line
                         into a line of text compatible with Expert Help.
   called function(s)..: ConvertToEH()
   calling function(s).: MenuEH()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: ConvertToEH() MenuEH()
   EXPERTEND
////

FUNCTION CamelotLOGO(nTop,nBeg,nBot,nEnd,cBOXcolor,cELEcolor,cCHRcolor,cCHR)

////
   EXPERTBEGIN
   !short: CamelotLOGO() Display Camelot South company logo.

   syntax..............: CamelotLOGO(<top>,<left>,<bottom>,<right>,;
                                     <box color>,<element color>,
                                     <chr color>,<character>)
   parameters passed...: nTop      = screen coordinate.
                         nBeg      = ""
                         nBot      = ""
                         nEnd      = ""
                         cBOXcolor = box color.
                         cELEcolor = array element color.
                         cCHRcolor = clear character color.
                         cCHR      = clear character.
   return value........: nil.
   action..............: display camelot south logo.
   notes...............: none.
   called function(s)..: none.
   calling function(s).: OpenEH()
                         globally.
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: OpenEH()
   EXPERTEND
////

FUNCTION ConvertToEH(cString)

////
   EXPERTBEGIN          .
   !short: ConvertToEH() Modify a line to conform to EHMAKER.CFG settings.
   syntax..............: ConvertToEH(<string>)
   parameters passed...: cString  = line of text to be modified.
   return value........: modified cString.
   action..............: use static arrays to modify a line of text.
   notes...............: the string passed will be modified based on values
                         stored in the static arrays aEHcolors and
                         aEHconfig.  uses these values to determine the
                         configuration of each line of text.
   called function(s)..: none.
   calling function(s).: BlockEH()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: BlockEH()
   EXPERTEND
////

FUNCTION DOSparams(aDOSpass)

////
   EXPERTBEGIN
   !short: DOSparams()   Evaluate parameters from DOS passed to EHmaker.

   syntax..............: DOSparams(<array>)
   parameters passed...: aDOSpass  = array of parameters.
   return value........: nil.
   action..............: parse out the array and set statics.
   notes...............: uses an array of values to set static variables.
                         parses values and sets statics.
   called function(s)..: PATHfiles()
   calling function(s).: OpenEH()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: OpenEH() PATHfiles()
   EXPERTEND
////

 UNCTION EHmaker()

////
   EXPERTBEGIN
   !short: EHmaker()  Use an array of .prg's to develop an Expert Help file.

   syntax..............: EHmaker(<>)
   parameters passed...: nil.
   return value........: nil.
   action..............: create an Expert Help test file.
   notes...............: topmost, controlling menu function.  access all of
                         the .prg's on disk and selectively creates files
                         compatible with the Expert Help compiler.  uses a
                         "template.eh", and "ehmaker.cfg" text file located
                         in the clipper \include subdirectory.  counterpart
                         for dos driven use is BatchEH().
   called function(s)..: Elevator()     // bar display called via achoice()
                                           udf ElevatorUDF().
                         ElevatorUDF()  // achoice() udf.
                         MenuEH()       // building block/parsing function.
                         ScrollHits()   // display selected file names.
   calling function(s).: none.
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: Elevator() ElevatorUDF() MenuEH() ScrollHits()
   EXPERTEND
////

FUNCTION Elevator(nElement,nPosition,aLength)

////
   EXPERTBEGIN
   !short: Elevator()    Elevator bar display indicating scroll position.

   syntax..............: Elevator(<array element>,<array position>,;
                                   <array length>)
   parameters passed...: nElement  = array element.
                         nPosition = relative position.
   return value........: nil.
   action..............: display an elevator bar as a progress indicator.
   notes...............: uses a static array, and static variables for
                         screen positioning (top, left, bottom & right).
                         these coordinates are set in the calling program.
   called function(s)..: none.
   calling function(s).: ElevatorUDF() via achoice() in EHmaker()
   related functions(s): ElevatorUDF().
   revision history....: written in 1992.
   credits.............: Don Allred of the LA Clipper User's Group.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: EHmaker() ElevatorUDF()
   EXPERTEND
////

FUNCTION ElevatorUDF(aStatus,nELE,nPOS)

////
   EXPERTBEGIN
   !short: ElevatorUDF() ACHOICE() udf which calls the function Elevator().

   syntax..............: ElevatorUDF(<status>,<current position>,
                                    <relative position>)
   parameters passed...: achoice() defaults.
   return value........: appropriate achoice() mode 1,2,3.
   action..............: selectable achoice function.
   notes...............: gerneric scroll udf for achoice().
                         unless scrolling keys are involved, returns
                         AC_CONT (2) as a value which allows array to be
                         continue.  exit with escape alt-q.
                         if the elevator display is to be used, the calling
                         function must reside in the same .prg to access
                         the static variables.
   called function(s)..: Elevator().
   calling function(s).: achoice() within EHmaker().
   related functions(s): Elevator().
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: EHmaker() Elevator()
   EXPERTEND
////

FUNCTION MenuEH(aChoices)

////
   EXPERTBEGIN
   !short: MenuEH()     Compare arrays text/template for Expert Help.

   syntax..............: MenuEH(<array>)
   parameters passed...: aChoices    = array of selected .prg files.
   return value........: nil.
   action..............: build and array from .prg files
   notes...............: access the .prg files, store them to an array and
                         pass the name of the individual files to BlockEH()
                         where the .prg is developed into an array which is
                         passed back to this function for printing.
   called function(s)..: BlockEH() = develop an array of arrays containing
                                     individual lines.
                         WriteEH() = write the array to disk (additively
                                     when accessing more than one .prg).
   calling function(s).: EHmaker().
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: BlockEH() EHmaker() WriteEH()
   EXPERTEND
////

FUNCTION PATHfiles(cPath)

////
   EXPERTBEGIN
   !short: PATHfiles()  Check to verify DOS path parameters, etc..

   syntax..............: PATHfiles(<path>)
   parameters passed...: cPath  = present syntax.
   return value........: modified path statement.
   action..............: check the syntax of the path statement.
   notes...............: checks path syntax verrifies valid path and
                         querries for new path.
   called function(s)..: none.
   calling function(s).: DOSparams()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: DOSparams()
   EXPERTEND
////

FUNCTION QuitEH(lMsg)

////
   EXPERTBEGIN
   !short: QuitEH()  Quit EHmaker.

   syntax..............: QuitEH(<message>)
   parameters passed...: lMsg  = display for parameter /?.
   return value........: NIL
   action..............: display message and quit.
   notes...............: none.
   called function(s)..: none.
   calling function(s).: OpenEH()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: OpenEH() DOSparams()
   EXPERTEND
////

FUNCTION ScrollHits(aHaveIT,nRow,nCol,nWidth)

////
   EXPERTBEGIN
   !short: ScrollHits()  Displays a List of Previously Selected Files.

   syntax..............: ScrollHits(<array>,<row>,<col>,<width>)
   parameters passed...: aHaveIT  = array of selected prgs.
                         nRow     = starting display row.
                         nCol     = starting column display.
                         nWidth   = width of column.
   return value........: nil.
   action..............: scroll an array of selections.
   notes...............: this function is used to create a display of
                         files that have been selected when using EHmaker
                         in the menu driven mode to provide visual
                         confirmation of the files already selected.  the
                         display area is sized by the number of valid
                         array elements up to a limit of 12.
   called function(s)..: none
   calling function(s).: EHmaker()
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso:  EHmaker()
   EXPERTEND
////

FUNCTION TemplateEH(cFile)

////
   EXPERTBEGIN
   !short: TemplateEH()  Build template and config arrays from files.

   syntax..............: TemplateEH(<file>)
   parameters passed...: cFile   = file name.
   return value........: nil.
   action..............: build an array of template values and referee
                         the development of subarrays.
   notes...............: use a file in the clipper subdirectory '\include'
                         to use in developing an arrays of values for
                         parsing and printing the Expert Help file.
                         processes the 'template.eh' and 'ehmaker.cfg'
                         files.
   called function(s)..: none.
   calling function(s).: OpenEH()   // opening function.
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso:  OpenEH()
   EXPERTEND
////

FUNCTION WriteEH(aWorking,cPRG,cText)

////
   EXPERTBEGIN
   !short: WriteEH()     Write an array of function headings to a .txt file.

   syntax..............: WriteEH(<array>,<.prg>)
   parameters passed...: aWorking   = array of function headings.
                         cPrg       = .prg accessed by the program.
   return value........: nil.
   action..............: loop through the array and print it.
   notes...............: special attention is needed for dos parameter
                         passes which may contain a path.  if a different
                         path is specified for writing eh files the path
                         with the file name needs to be stripped out.
                         the see also heading is parsed out into three lines
                         one with the full see also line, another with the
                         function heading highlighted and a third with the
                         function description.
                         another optional line is for 'revision'.  if this
                         term is present the phrase 'latest:' with the file
                         date/time stamp is included.
   called function(s)..: none
   calling function(s).: BatchEH()   // dos driven.
                         MenuEH()    // menu driven.
   related functions(s): none.
   revision history....: written in 1992.
   credits.............: none.
   copyright notice....: copyright (c), 1992, all rights reserved.
                                     William R. Treese
                                       Camelot South
                                     Santa Barbara, CA.

   !seealso: BatchEH() MenuEH()
   EXPERTEND
////

